dnl
dnl $Id: config.m4,v 1.6 2003/06/30 17:23:52 sniper Exp $
dnl

PHP_ARG_WITH(xsl, for XSL support,
[  --with-xsl[=DIR]        Include new XSL support (requires libxslt >= 1.0.18).
                          DIR is the libxslt install directory.])

if test "$PHP_XSL" != "no" -a "$PHP_DOM" = "no"; then
  AC_MSG_ERROR([XSL extension requires DOM extension, add --enable-dom.])
fi

if test "$PHP_XSL" != "no"; then

  for i in $PHP_XSL /usr/local /usr; do
    if test -x "$i/bin/xslt-config"; then
      XSLT_CONFIG=$i/bin/xslt-config
      break
    fi
  done

  if test -z "$XSLT_CONFIG"; then
    AC_MSG_ERROR([xslt-config not found. Please reinstall the libxslt >= 1.0.18 distribution])
  else
    libxslt_full_version=`$XSLT_CONFIG --version`
    ac_IFS=$IFS
    IFS="."
    set $libxslt_full_version
    IFS=$ac_IFS
    LIBXSLT_VERSION=`expr [$]1 \* 1000000 + [$]2 \* 1000 + [$]3`
    if test "$LIBXSLT_VERSION" -ge "1000018"; then
      XSL_LIBS=`$XSLT_CONFIG --libs`
      XSL_INCS=`$XSLT_CONFIG --cflags`
      PHP_EVAL_LIBLINE($XSL_LIBS, XSL_SHARED_LIBADD)
      PHP_EVAL_INCLINE($XSL_INCS)
    else
      AC_MSG_ERROR([libxslt version 1.0.18 or greater required.])
    fi
  fi
  
  AC_DEFINE(HAVE_XSL,1,[ ])
  PHP_NEW_EXTENSION(xsl, php_xsl.c xsltprocessor.c, $ext_shared)
  PHP_SUBST(XSL_SHARED_LIBADD)
fi
