--TEST--
ZE2 iterators and break
--SKIPIF--
<?php if (version_compare(zend_version(), '2.0.0-dev', '<')) die('skip ZendEngine 2 needed'); ?>
<?php if (!class_exists('Iterator')) print "skip interface iterator doesn't exist"; ?>
--FILE--
<?php
class c_iter implements Iterator {

	private $obj;
	private $num = 0;

	function __construct($obj) {
		echo __METHOD__ . "\n";
		$this->obj = $obj;
	}
	function rewind() {
		echo __METHOD__ . "\n";
		$this->num = 0;
	}
	function hasMore() {
		$more = $this->num < $this->obj->max;
		echo __METHOD__ . ' = ' .($more ? 'true' : 'false') . "\n";
		return $more;
	}
	function current() {
		echo __METHOD__ . "\n";
		return $this->num;
	}
	function next() {
		echo __METHOD__ . "\n";
		$this->num++;
	}
	function key() {
		echo __METHOD__ . "\n";
		switch($this->num) {
			case 0: return "1st";
			case 1: return "2nd";
			case 2: return "3rd";
			default: return "???";
		}
	}
	function __destruct() {
		echo __METHOD__ . "\n";
	}
}
	
class c implements IteratorAggregate {

	public $max = 3;

	function getIterator() {
		echo __METHOD__ . "\n";
		return new c_iter($this);
	}
	function __destruct() {
		echo __METHOD__ . "\n";
	}
}

$t = new c();

foreach($t as $v) {
	foreach($t as $w) {
		echo "double:$v:$w\n";
		break;
	}
}

unset($t);

print "Done\n";
?>
--EXPECT--
c::getIterator
c_iter::__construct
c_iter::rewind
c_iter::hasMore = true
c_iter::current
c_iter::key
c_iter::next
c::getIterator
c_iter::__construct
c_iter::rewind
c_iter::hasMore = true
c_iter::current
c_iter::key
c_iter::next
double:0:0
c_iter::__destruct
c_iter::hasMore = true
c_iter::current
c_iter::key
c_iter::next
c::getIterator
c_iter::__construct
c_iter::rewind
c_iter::hasMore = true
c_iter::current
c_iter::key
c_iter::next
double:1:0
c_iter::__destruct
c_iter::hasMore = true
c_iter::current
c_iter::key
c_iter::next
c::getIterator
c_iter::__construct
c_iter::rewind
c_iter::hasMore = true
c_iter::current
c_iter::key
c_iter::next
double:2:0
c_iter::__destruct
c_iter::hasMore = false
c_iter::__destruct
c::__destruct
Done
